///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ARM ANSI C/C++ Compiler V5.11.0.50622/W32        10/Jul/2008  15:24:44 /
// Copyright 1999-2007 IAR Systems. All rights reserved.                      /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  D:\trv\euro\Developers\firmware\at91lib\boards\at91sam7 /
//                    l-ek\board_memories.c                                   /
//    Command line =  D:\trv\euro\Developers\firmware\at91lib\boards\at91sam7 /
//                    l-ek\board_memories.c -D at91sam7l128 -D flash -D       /
//                    _ARM_ -lC D:\trv\euro\Developers\firmware\AT91SAM7L\ewp /
//                    \at91sam7l128_flash\List\ -lB                           /
//                    D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\at91sam7l /
//                    128_flash\List\ --remarks --diag_suppress Pe826,Pe1375  /
//                    -o D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\at91sa /
//                    m7l128_flash\Obj\ --no_unroll --debug --endian little   /
//                    --cpu ARM7TDMI -e --fpu None -I                         /
//                    D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\..\src\   /
//                    -I D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\..\..\ /
//                     -I D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\..\.. /
//                    \napier\ -I D:\trv\euro\Developers\firmware\AT91SAM7L\e /
//                    wp\..\..\at91lib\ -I D:\trv\euro\Developers\firmware\AT /
//                    91SAM7L\ewp\..\..\at91lib\boards\at91sam7l-ek\ -I       /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.0\ARM\INC\" --interwork --cpu_mode thumb -Ohz         /
//    List file    =  D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\at91sam7l /
//                    128_flash\List\board_memories.s                         /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME board_memories

        PUBLIC BOARD_RemapFlash
        PUBLIC BOARD_RemapRam

// D:\trv\euro\Developers\firmware\at91lib\boards\at91sam7l-ek\board_memories.c
//    1 /* ----------------------------------------------------------------------------
//    2  *         ATMEL Microcontroller Software Support 
//    3  * ----------------------------------------------------------------------------
//    4  * Copyright (c) 2008, Atmel Corporation
//    5  *
//    6  * All rights reserved.
//    7  *
//    8  * Redistribution and use in source and binary forms, with or without
//    9  * modification, are permitted provided that the following conditions are met:
//   10  *
//   11  * - Redistributions of source code must retain the above copyright notice,
//   12  * this list of conditions and the disclaimer below.
//   13  *
//   14  * Atmel's name may not be used to endorse or promote products derived from
//   15  * this software without specific prior written permission.
//   16  *
//   17  * DISCLAIMER: THIS SOFTWARE IS PROVIDED BY ATMEL "AS IS" AND ANY EXPRESS OR
//   18  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
//   19  * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
//   20  * DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
//   21  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//   22  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
//   23  * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//   24  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//   25  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//   26  * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//   27  * ----------------------------------------------------------------------------
//   28  */
//   29 
//   30 //------------------------------------------------------------------------------
//   31 //         Headers
//   32 //------------------------------------------------------------------------------
//   33 
//   34 #include "board_memories.h"
//   35 #include "board.h"
//   36 
//   37 //------------------------------------------------------------------------------
//   38 //         Internal definitions
//   39 //------------------------------------------------------------------------------
//   40 
//   41 /// \internal Flash is mirrored in the remap zone.
//   42 #define BOARD_FLASH             0
//   43 
//   44 /// \internal RAM is mirrored in the remap zone.
//   45 #define BOARD_RAM               1
//   46 
//   47 //------------------------------------------------------------------------------
//   48 //         Internal function
//   49 //------------------------------------------------------------------------------
//   50 //------------------------------------------------------------------------------
//   51 /// Returns the current remap, either BOARD_FLASH or BOARD_RAM.
//   52 //------------------------------------------------------------------------------

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//   53 static unsigned char BOARD_GetRemap( void )
//   54 {
BOARD_GetRemap:
        PUSH     {R0,LR}
//   55     unsigned int *remap = (unsigned int *) 0;
//   56     unsigned int *ram = (unsigned int *) AT91C_ISRAM_1;
//   57 
//   58     // Try to write in 0 and see if this affects the RAM
//   59     unsigned int temp = *ram;
        MOVS     R0,#+128
        LSLS     R0,R0,#+14       ;; #+2097152
        LDR      R1,[R0, #+0]
//   60     *ram = temp + 1;
        ADDS     R2,R1,#+1
        STR      R2,[R0, #+0]
//   61     if (*remap == *ram) {
        MOVS     R2,#+0
        LDR      R2,[R2, #+0]
        LDR      R3,[R0, #+0]
        CMP      R2,R3
        STR      R1,[R0, #+0]
        BNE      ??BOARD_GetRemap_0
//   62 
//   63         *ram = temp;
//   64         return BOARD_RAM;
        MOVS     R0,#+1
        B        ??BOARD_GetRemap_1
//   65     }
//   66     else {
//   67 
//   68         *ram = temp;
//   69         return BOARD_FLASH;
??BOARD_GetRemap_0:
        MOVS     R0,#+0
??BOARD_GetRemap_1:
        POP      {R3}
        POP      {R1}
        BX       R1               ;; return
//   70     }
//   71 }
//   72 
//   73 //------------------------------------------------------------------------------
//   74 //         Exported functions
//   75 //------------------------------------------------------------------------------
//   76 //------------------------------------------------------------------------------
//   77 /// Changes the mapping of the chip so that the remap area mirrors the
//   78 /// internal flash.
//   79 //------------------------------------------------------------------------------

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//   80 void BOARD_RemapFlash( void )
//   81 {
BOARD_RemapFlash:
        PUSH     {R0,LR}
//   82     if (BOARD_GetRemap() != BOARD_FLASH) {
        BL       BOARD_GetRemap
        CMP      R0,#+0
        B.N      ?Subroutine0
//   83 
//   84         AT91C_BASE_MC->MC_RCR = AT91C_MC_RCB;
//   85     }
//   86 }
//   87 
//   88 //------------------------------------------------------------------------------
//   89 /// Changes the mapping of the chip so that the remap area mirrors the
//   90 /// internal RAM.
//   91 //------------------------------------------------------------------------------

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//   92 void BOARD_RemapRam( void )
//   93 {
BOARD_RemapRam:
        PUSH     {R0,LR}
//   94     if (BOARD_GetRemap() != BOARD_RAM) {
        BL       BOARD_GetRemap
        CMP      R0,#+1
        REQUIRE ?Subroutine0
        ;; // Fall through to label ?Subroutine0
//   95 
//   96         AT91C_BASE_MC->MC_RCR = AT91C_MC_RCB;
//   97     }
//   98 }

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
?Subroutine0:
        BEQ      ??Subroutine0_0
        MOVS     R0,#+255
        MVNS     R0,R0            ;; #-256
        MOVS     R1,#+1
        STR      R1,[R0, #+0]
??Subroutine0_0:
        POP      {R3}
        POP      {R0}
        BX       R0               ;; return

        END
//   99 
// 
// 70 bytes in section .text
// 
// 70 bytes of CODE memory
//
//Errors: none
//Warnings: none
