///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ARM ANSI C/C++ Compiler V5.11.0.50622/W32        10/Jul/2008  15:24:44 /
// Copyright 1999-2007 IAR Systems. All rights reserved.                      /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  D:\trv\euro\Developers\firmware\at91lib\boards\at91sam7 /
//                    l-ek\board_lowlevel.c                                   /
//    Command line =  D:\trv\euro\Developers\firmware\at91lib\boards\at91sam7 /
//                    l-ek\board_lowlevel.c -D at91sam7l128 -D flash -D       /
//                    _ARM_ -lC D:\trv\euro\Developers\firmware\AT91SAM7L\ewp /
//                    \at91sam7l128_flash\List\ -lB                           /
//                    D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\at91sam7l /
//                    128_flash\List\ --remarks --diag_suppress Pe826,Pe1375  /
//                    -o D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\at91sa /
//                    m7l128_flash\Obj\ --no_unroll --debug --endian little   /
//                    --cpu ARM7TDMI -e --fpu None -I                         /
//                    D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\..\src\   /
//                    -I D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\..\..\ /
//                     -I D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\..\.. /
//                    \napier\ -I D:\trv\euro\Developers\firmware\AT91SAM7L\e /
//                    wp\..\..\at91lib\ -I D:\trv\euro\Developers\firmware\AT /
//                    91SAM7L\ewp\..\..\at91lib\boards\at91sam7l-ek\ -I       /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.0\ARM\INC\" --interwork --cpu_mode thumb -Ohz         /
//    List file    =  D:\trv\euro\Developers\firmware\AT91SAM7L\ewp\at91sam7l /
//                    128_flash\List\board_lowlevel.s                         /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME board_lowlevel

        EXTERN BOARD_RemapRam

        PUBLIC LowLevelInit
        PUBLIC defaultFiqHandler
        PUBLIC defaultIrqHandler
        PUBLIC defaultSpuriousHandler
        PUBLIC gLowLevelInitSupcStatus

// D:\trv\euro\Developers\firmware\at91lib\boards\at91sam7l-ek\board_lowlevel.c
//    1 /* ----------------------------------------------------------------------------
//    2  *         ATMEL Microcontroller Software Support 
//    3  * ----------------------------------------------------------------------------
//    4  * Copyright (c) 2008, Atmel Corporation
//    5  *
//    6  * All rights reserved.
//    7  *
//    8  * Redistribution and use in source and binary forms, with or without
//    9  * modification, are permitted provided that the following conditions are met:
//   10  *
//   11  * - Redistributions of source code must retain the above copyright notice,
//   12  * this list of conditions and the disclaimer below.
//   13  *
//   14  * Atmel's name may not be used to endorse or promote products derived from
//   15  * this software without specific prior written permission.
//   16  *
//   17  * DISCLAIMER: THIS SOFTWARE IS PROVIDED BY ATMEL "AS IS" AND ANY EXPRESS OR
//   18  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
//   19  * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
//   20  * DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
//   21  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//   22  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
//   23  * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//   24  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//   25  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//   26  * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//   27  * ----------------------------------------------------------------------------
//   28  */
//   29 
//   30 //------------------------------------------------------------------------------
//   31 //         Headers
//   32 //------------------------------------------------------------------------------
//   33 
//   34 #include "board.h"
//   35 #include "board_memories.h"
//   36 
//   37 //------------------------------------------------------------------------------
//   38 //         Local definitions
//   39 //------------------------------------------------------------------------------
//   40 
//   41 /// PLL frequency range.
//   42 #define BOARD_CKGR_PLL          AT91C_CKGR_OUT_2
//   43 
//   44 /// PLL startup time (in number of slow clock ticks).
//   45 #define BOARD_PLLCOUNT          AT91C_CKGR_PLLCOUNT
//   46 
//   47 /// PLL MUL value.
//   48 #define BOARD_MUL               (914 << 16)
//   49 
//   50 /// PLL DIV value.
//   51 #define BOARD_DIV               1
//   52 
//   53 /// Master clock prescaler value.
//   54 #define BOARD_PRESCALER         0
//   55 
//   56 //------------------------------------------------------------------------------
//   57 //         Global variables
//   58 //------------------------------------------------------------------------------
//   59 
//   60 // SUPC status value read during LowLevelInit(), discarded by read.

        SECTION `.bss`:DATA:NOROOT(2)
//   61 unsigned int gLowLevelInitSupcStatus;
gLowLevelInitSupcStatus:
        DS8 4
//   62 
//   63 //------------------------------------------------------------------------------
//   64 //         Local functions
//   65 //------------------------------------------------------------------------------
//   66 
//   67 //------------------------------------------------------------------------------
//   68 /// Default spurious interrupt handler. Infinite loop.
//   69 //------------------------------------------------------------------------------

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//   70 void defaultSpuriousHandler(void)
//   71 { // reset CPU
//   72   AT91C_BASE_RSTC->RSTC_RCR= (0xA5 << 24)|AT91C_RSTC_PROCRST|AT91C_RSTC_PERRST|AT91C_RSTC_EXTRST;
defaultSpuriousHandler:
        B.N      ?Subroutine0
//   73 //    while (1);
//   74 }
//   75 
//   76 //------------------------------------------------------------------------------
//   77 /// Default handler for fast interrupt requests. Infinite loop.
//   78 //------------------------------------------------------------------------------

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//   79 void defaultFiqHandler(void)
//   80 { // reset CPU
//   81   AT91C_BASE_RSTC->RSTC_RCR= (0xA5 << 24)|AT91C_RSTC_PROCRST|AT91C_RSTC_PERRST|AT91C_RSTC_EXTRST;
defaultFiqHandler:
        REQUIRE ?Subroutine0
        ;; // Fall through to label ?Subroutine0

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
?Subroutine0:
        LDR      R0,??Subroutine0_0  ;; 0xfffffd00
        LDR      R1,??Subroutine0_0+0x4  ;; 0xa500000d
        STR      R1,[R0, #+0]
        BX       LR               ;; return
        DATA
??Subroutine0_0:
        DC32     0xfffffd00
        DC32     0xa500000d
//   82 //    while (1);
//   83 }
//   84 
//   85 //------------------------------------------------------------------------------
//   86 /// Default handler for standard interrupt requests. Infinite loop.
//   87 //------------------------------------------------------------------------------

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//   88 void defaultIrqHandler(void)
//   89 { // reset CPU
//   90   AT91C_BASE_RSTC->RSTC_RCR= (0xA5 << 24)|AT91C_RSTC_PROCRST|AT91C_RSTC_PERRST|AT91C_RSTC_EXTRST;
defaultIrqHandler:
        B.N      ?Subroutine0
//   91 //    while (1);
//   92 }
//   93 
//   94 //------------------------------------------------------------------------------
//   95 //         Exported functions
//   96 //------------------------------------------------------------------------------
//   97 
//   98 //------------------------------------------------------------------------------
//   99 /// Performs the low-level initialization of the chip. This includes EFC, master
//  100 /// clock, AIC & watchdog configuration, as well as memory remapping.
//  101 //------------------------------------------------------------------------------

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  102 void LowLevelInit(void)
//  103 {
LowLevelInit:
        PUSH     {R0,R1,R4,LR}
//  104     volatile unsigned int i;
//  105 
//  106     // Set flash wait states in the EFC
//  107     // 48MHz = 1 wait state
//  108 /*
//  109 #if defined(at91sam7l64) || defined(at91sam7l128)
//  110     AT91C_BASE_MC->MC_FMR = AT91C_MC_FWS_3FWS;
//  111 #else
//  112     #error No chip definition ?
//  113 #endif
//  114 */
//  115     
//  116     // Enable external oscillator (on first boot only, after that command does nothing)
//  117 /*    gLowLevelInitSupcStatus = AT91C_BASE_SUPC->SUPC_SR;
//  118     if ((gLowLevelInitSupcStatus & AT91C_SUPC_OSCSEL) != AT91C_SUPC_OSCSEL) {
//  119         
//  120         AT91C_BASE_SUPC->SUPC_CR = (0xA5 << 24) | AT91C_SUPC_XTALSEL;
//  121         while ((AT91C_BASE_SUPC->SUPC_SR & AT91C_SUPC_OSCSEL) != AT91C_SUPC_OSCSEL);
//  122     }
//  123 
//  124     // Switch to slow clock if necessary (so PLL frequency can be changed)
//  125     if ((AT91C_BASE_PMC->PMC_MCKR & AT91C_PMC_CSS) == AT91C_PMC_CSS_PLL_CLK) {
//  126 
//  127         AT91C_BASE_PMC->PMC_MCKR = AT91C_PMC_CSS_SLOW_CLK;
//  128         while ((AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MCKRDY) != AT91C_PMC_MCKRDY);
//  129     }
//  130 
//  131     // Initialize PLL at 30MHz
//  132     AT91C_BASE_PMC->PMC_PLLR = BOARD_CKGR_PLL | BOARD_PLLCOUNT | BOARD_MUL | BOARD_DIV;
//  133     while ((AT91C_BASE_PMC->PMC_SR & AT91C_PMC_LOCK) == 0);
//  134 
//  135     // Switch to PLL
//  136     AT91C_BASE_PMC->PMC_MCKR = AT91C_PMC_CSS_PLL_CLK;
//  137     while ((AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MCKRDY) == 0);
//  138 */
//  139     /////////////////////////////////////////////////////////////////////////////////////////////////////
//  140     // Init PMC (in case the chip has booted from ROM code)
//  141     // Selection of Master Clock MCK (equal to Processor Clock PCK) equal to 2MHz
//  142     /////////////////////////////////////////////////////////////////////////////////////////////////////
//  143     AT91C_BASE_PMC->PMC_MCKR = AT91C_PMC_CSS_MAIN_CLK;
        LDR      R2,??LowLevelInit_0  ;; 0xfffffc30
        MOVS     R0,#+1
        STR      R0,[R2, #+0]
        MOVS     R4,#+8
//  144     // Wait until the master clock is established
//  145     while( !(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MCKRDY) );
??LowLevelInit_1:
        LDR      R3,[R2, #+56]
        TST      R3,R4
        BEQ      ??LowLevelInit_1
//  146 
//  147     AT91C_BASE_PMC->PMC_MCKR |= AT91C_PMC_PRES_CLK;
        LDR      R3,[R2, #+0]
        STR      R3,[R2, #+0]
        MOVS     R3,#+8
//  148     // Wait until the master clock is established
//  149     while( !(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MCKRDY) );
??LowLevelInit_2:
        LDR      R2,??LowLevelInit_0  ;; 0xfffffc30
        LDR      R2,[R2, #+56]
        TST      R2,R3
        BEQ      ??LowLevelInit_2
//  150 
//  151     /////////////////////////////////////////////////////////////////////////////////////////////////////
//  152     //  Disable Watchdog (write once register)
//  153     /////////////////////////////////////////////////////////////////////////////////////////////////////
//  154 //    AT91C_BASE_WDTC->WDTC_WDMR = AT91C_WDTC_WDDIS;
//  155     /////////////////////////////////////////////////////////////////////////////////////////////////////
//  156     //  Enable Watchdog (write once register)
//  157     /////////////////////////////////////////////////////////////////////////////////////////////////////
//  158     AT91C_BASE_WDTC->WDTC_WDMR = 
//  159 (AT91C_WDTC_WDV/8) |       //(0xFFF <<  0) // (WDTC) Watchdog Timer Restart set to 2 second
//  160 //AT91C_WDTC_WDFIEN     //(0x1 << 12) // (WDTC) Watchdog Fault Interrupt Enable
//  161 AT91C_WDTC_WDRSTEN |   //(0x1 << 13) // (WDTC) Watchdog Reset Enable
//  162 //AT91C_WDTC_WDRPROC    //(0x1 << 14) // (WDTC) Watchdog Timer Restart
//  163 //AT91C_WDTC_WDDIS      //(0x1 << 15) // (WDTC) Watchdog Disable
//  164 AT91C_WDTC_WDD |       //(0xFFF << 16) // (WDTC) Watchdog Delta Value
//  165 AT91C_WDTC_WDDBGHLT   //(0x1 << 28) // (WDTC) Watchdog Debug Halt
//  166 //AT91C_WDTC_WDIDLEHLT  //(0x1 << 29) // (WDTC) Watchdog Idle Halt
//  167 ;
        LDR      R1,??LowLevelInit_0+0x4  ;; 0xfffffd54
        LDR      R2,??LowLevelInit_0+0x8  ;; 0x1fff21ff
        STR      R2,[R1, #+0]
//  168 
//  169     // Initialize AIC
//  170     AT91C_BASE_AIC->AIC_IDCR = 0xFFFFFFFF;
        LDR      R1,??LowLevelInit_0+0xC  ;; 0xfffff124
        MOVS     R2,#+0
        MVNS     R2,R2            ;; #-1
        STR      R2,[R1, #+0]
//  171     AT91C_BASE_AIC->AIC_SVR[0] = (unsigned int) defaultFiqHandler;
        LDR      R1,??LowLevelInit_0+0x10  ;; 0xfffff080
        LDR      R2,??LowLevelInit_0+0x14  ;; defaultFiqHandler
        STR      R2,[R1, #+0]
//  172     for (i = 1; i < 31; i++) {
        STR      R0,[SP, #+0]
        LDR      R1,??LowLevelInit_0+0x18  ;; defaultIrqHandler
        LDR      R3,??LowLevelInit_0+0x10  ;; 0xfffff080
        B        ??LowLevelInit_3
//  173 
//  174         AT91C_BASE_AIC->AIC_SVR[i] = (unsigned int) defaultIrqHandler;
??LowLevelInit_4:
        LDR      R2,[SP, #+0]
        LSLS     R2,R2,#+2
        STR      R1,[R3, R2]
//  175     }
        LDR      R2,[SP, #+0]
        ADDS     R2,R2,#+1
        STR      R2,[SP, #+0]
??LowLevelInit_3:
        LDR      R2,[SP, #+0]
        CMP      R2,#+31
        BCC      ??LowLevelInit_4
//  176     AT91C_BASE_AIC->AIC_SPU = (unsigned int) defaultSpuriousHandler;
        LDR      R1,??LowLevelInit_0+0xC  ;; 0xfffff124
        LDR      R2,??LowLevelInit_0+0x1C  ;; defaultSpuriousHandler
        STR      R2,[R1, #+16]
//  177 
//  178     // Unstack nested interrupts
//  179     for (i = 0; i < 8 ; i++) {
        MOVS     R1,#+0
        STR      R1,[SP, #+0]
        B        ??LowLevelInit_5
//  180 
//  181         AT91C_BASE_AIC->AIC_EOICR = 0;
??LowLevelInit_6:
        LDR      R2,??LowLevelInit_0+0xC  ;; 0xfffff124
        STR      R1,[R2, #+12]
//  182     }
        LDR      R2,[SP, #+0]
        ADDS     R2,R2,#+1
        STR      R2,[SP, #+0]
??LowLevelInit_5:
        LDR      R2,[SP, #+0]
        CMP      R2,#+8
        BCC      ??LowLevelInit_6
//  183 
//  184     // Enable Debug mode
//  185     AT91C_BASE_AIC->AIC_DCR = AT91C_AIC_DCR_PROT;
        LDR      R1,??LowLevelInit_0+0xC  ;; 0xfffff124
        STR      R0,[R1, #+20]
//  186 
//  187     // Remap the internal SRAM at 0x0
//  188     BOARD_RemapRam();
        BL       BOARD_RemapRam
//  189 }
        POP      {R2-R4}
        POP      {R0}
        BX       R0               ;; return
        Nop      
        DATA
??LowLevelInit_0:
        DC32     0xfffffc30
        DC32     0xfffffd54
        DC32     0x1fff21ff
        DC32     0xfffff124
        DC32     0xfffff080
        DC32     defaultFiqHandler
        DC32     defaultIrqHandler
        DC32     defaultSpuriousHandler

        END
//  190 
// 
//   4 bytes in section .bss
// 172 bytes in section .text
// 
// 172 bytes of CODE memory
//   4 bytes of DATA memory
//
//Errors: none
//Warnings: none
